<ng-container *transloco="let t; prefix: 'agentConfiguration'">
  <div class="col-12 d-flex row justify-content-start align-items-center">
    <div class="col-12 mt-3">{{ t('csrGeneration.certificateSigningRequestDescription') }}</div>
    <div class="col-12 mt-3 justify-content-center">
      <button [disabled]="!hasKeypair" euiButton euiPrimary (click)="launchCertificateSigningRequest()">
        <span euiLabel>{{ t('csrGeneration.launchCertificateSigningRequest') }}</span>
      </button>

      <eui-dialog #dialog
                  [title]="t('csrGeneration.title')"
                  [dismissLabel]="t('csrGeneration.cancel')"
                  [acceptLabel]="t('csrGeneration.confirm')"
                  (accept)="onAccept()"
                  (dismiss)="onDismiss()">
        <ng-container>
          @switch (status) {
            @case ("loading") {
              <div class="w-full d-flex row items-center justify-content-center py-2">
                <eui-progress-bar isIndeterminate=""></eui-progress-bar>
              </div>
            }
            @case ("prompt") {
              <form [formGroup]="csrDetailsForm">
                <div class="row">
                  <p>{{ t('csrGeneration.message') }}</p>
                </div>
                <div euiInputGroup>
                  <label euiLabel euiRequired="" for="common_name">{{ t('csrDetails.commonName') }}</label>
                  <input euiInputText id="common_name" formControlName="commonName"
                         placeholder="{{t('csrDetails.commonNamePlaceholder')}}" />
                </div>

                <div euiInputGroup>
                  <label euiLabel euiRequired="" for="organisation">{{ t('csrDetails.organisation') }}</label>
                  <input euiInputText id="organisation" formControlName="organization"
                         placeholder="{{t('csrDetails.organisationPlaceholder') }}" />
                </div>

                <div euiInputGroup>
                  <label euiLabel euiRequired="" for="organisation_unit">{{ t('csrDetails.organisationUnit') }}</label>
                  <input euiInputText id="organisation_unit" formControlName="organizationalUnit"
                         placeholder="{{t('csrDetails.organisationUnitPlaceholder') }}" />
                </div>

                <div euiInputGroup>
                  <label euiLabel euiRequired="" for="country">{{ t('csrDetails.country') }}</label>
                  <input euiInputText id="country" formControlName="country"
                         placeholder="{{t('csrDetails.countryPlaceholder') }}" />
                </div>
              </form>
            }
            @default {
              @if (status === "error") {
                <p class="text-danger">{{ t('csrGeneration.error') }}</p>
              } @else {
                <p class="text-success">{{ t('csrGeneration.success') }}</p>
              }
            }
          }
        </ng-container>
      </eui-dialog>
    </div>
  </div>
</ng-container>
